const http = require("http");
const express = require("express");
const cors = require("cors");
const colyseus = require("colyseus");
const monitor = require("@colyseus/monitor").monitor;
const socialRoutes = require("@colyseus/social/express").default;
const port = process.env.PORT || 2567;
const app = express();
const StarGazerRoom = require("./lib/rooms/StarGazerRoom");

app.use(cors());
app.use(express.json());

const server = http.createServer(app);
const gameServer = new colyseus.Server({
  server: server,
  express: app
});


gameServer.define("star_gazer_lab", StarGazerRoom);
app.use("/", socialRoutes);
app.use("/colyseus", monitor(gameServer));

gameServer.listen(port);
console.log(`Listening on ws://localhost:${ port }`)
